#include <descrip.h>
#include "clilib.h"

extern unsigned long LIB$SIG_TO_RET();

unsigned long
cli_present(char *s)
{
        static struct dsc$descriptor s_desc = {0,DSC$K_DTYPE_T,DSC$K_CLASS_S,0};
 
        s_desc.dsc$w_length = strlen(s);
        s_desc.dsc$a_pointer = s;
        return(cli$present(&s_desc) & 1);
}


unsigned long
cli_present2(char *s)
{
        static struct dsc$descriptor s_desc = {0,DSC$K_DTYPE_T,DSC$K_CLASS_S,0};
 
        s_desc.dsc$w_length = strlen(s);
        s_desc.dsc$a_pointer = s;
        cli$present(&s_desc);
}


unsigned long 
cli_get_value(char *s1,char **s2)
{
        static struct dsc$descriptor s1_desc={0,DSC$K_DTYPE_T,DSC$K_CLASS_S,0};
        static struct dsc$descriptor s2_desc={0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};
        static char null = '\0';
        static struct dsc$descriptor null_desc =
                {1,DSC$K_DTYPE_T,DSC$K_CLASS_S,&null};
        unsigned long status;
 
        s1_desc.dsc$w_length = strlen(s1);
        s1_desc.dsc$a_pointer = s1;
 
        status = CLI$GET_VALUE(&s1_desc,&s2_desc);
 
        if (status & 1)
        {
                str$append(&s2_desc,&null_desc);
                *s2 = s2_desc.dsc$a_pointer;
        }
        else
                *s2 = 0;
        return(status);
}


/* "table" is a pointer to the internal CLD
 * "name" is a text string containing the name of the verb
 */
unsigned long
init_cli(void *table, char *name)
{
        static struct dsc$descriptor cmd = {0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};
        static $DESCRIPTOR(verb,"$VERB");
        static $DESCRIPTOR(line,"$LINE");
        int i;
        unsigned long status;

        VAXC$ESTABLISH(LIB$SIG_TO_RET);       

        status = CLI$GET_VALUE(&verb,&cmd);

        if (!(status & 1))
                return(status);

        if (strncmp(cmd.dsc$a_pointer,name,cmd.dsc$w_length) == 0)
        {
                return(1);    /* the command must have been properly defined! */
        }
        else
        {
                /* assume that the verb is shorter than than the foreign
                        symbol (which includes device:[dir], so, should be ok */
                status = CLI$GET_VALUE(&line,&cmd);
                if (!(status & 1))
                        return(status);

                for (i = 0; (i < cmd.dsc$w_length) &&
                    (cmd.dsc$a_pointer[i] != ' ') &&
                    (cmd.dsc$a_pointer[i] != '/'); ++i)
                        cmd.dsc$a_pointer[i] = (i < strlen(name))?name[i]:' ';

                 /* initialize the parse tables */
                return(CLI$DCL_PARSE(&cmd,table));
        }
}
