/*
        SET PROCESS - set target process attributes

	Copyright (c) 1994	Ian Miller
	All rights reserved.

	Feel free to distribute this program as long as you keep this
	notice.

	THIS SOFTWARE IS PROVIDED AS IS AND WITHOUT ANY EXPRESS OR
	IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
	WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

  Edit History
  ============
  V01.1	01-May-1992	Ian Miller	Created.
  V01.2 15-May-1992	Ian Miller	Use rwproc function and expand.
  V01.3	25-Jun-1992	Ian Miller	Add /ACCOUNTING and /SERVICE_FAILURE
  V01.4 16-feb-1992	Ian Miller	Add more status bits.
  V01.5 31-Jan-1993     Ian Miller      Add /AST_ENABLED to enable user mode
                                        ASTs
*/
#module XSET_PROC "V01.5"
#include <descrip.h>
#include <dvidef.h>
#include <climsgdef.h>
#include "clilib.h"
#include "xset.h"


int setproc_cmd()
{
	char name[16], *p;
        unsigned long ccode,pid, mbunit;
        unsigned char asten = 0;
	$DESCRIPTOR(mbname_dsc,"");
	globalvalue int RWPROC_K_WRPCB,PCB$W_TMBU,RWPROC_K_WBPHD,PHD$V_IMGDMP,
                PHD$W_FLAGS,PCB$L_STS,RWPROC_K_WBPCB,PCB$V_SSRWAIT,
		PCB$V_PSWAPM,PCB$T_LNAME,PCB$S_LNAME,PCB$V_NOACNT,
		PCB$V_SSFEXCU,PCB$V_DELPEN,PCB$V_FORCPEN,PCB$V_RESPEN,
		PCB$V_SUSPEN,PCB$V_WAKEPEN,PCB$V_WALL,PCB$V_NOSUSPEND,
		PCB$V_NODELET,PCB$V_DISAWS;
	extern int rwproc(unsigned long pid,unsigned long function,
		unsigned long offset,unsigned short length,void *bufadr);
        extern int setast(unsigned long pid,unsigned char asten);

        ccode = get_processid(&pid);
	if (ccode & 1)
	{
		ccode = cli_present2("DUMP");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPHD,
				(PHD$V_IMGDMP<<16)+PHD$W_FLAGS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPHD,
				(PHD$V_IMGDMP<<16)+PHD$W_FLAGS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("MAILBOX");
		if  ((ccode & 1)
		&&  ((ccode = cli_get_value("MAILBOX",
			&mbname_dsc.dsc$a_pointer)) & 1))
		{
			/* XSET PROC/MAIL=mbname - so set term mailbox	*/
			mbname_dsc.dsc$w_length
				= strlen(mbname_dsc.dsc$a_pointer);
			ccode = LIB$GETDVI(&DVI$_UNIT,0,&mbname_dsc,&mbunit);
                        if (ccode & 1)
                        {
        			ccode = rwproc(pid,RWPROC_K_WRPCB,PCB$W_TMBU,
        				2,&mbunit);
                        }
			if ((ccode & 1) == 0)
				return ccode;
		}
		else if (ccode == CLI$_NEGATED)
		{
			/* XSET PROC/NOMAIL - so clear termination mailbox */
			ccode = rwproc(pid,RWPROC_K_WRPCB,PCB$W_TMBU,2,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("RESOURCE_WAIT");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_SSRWAIT<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_SSRWAIT<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("DELETE");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_NODELET<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_NODELET<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("AWSA");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_DISAWS<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_DISAWS<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("SUSPEND");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_NOSUSPEND<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_NOSUSPEND<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("DELETE_PENDING");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_DELPEN<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_DELPEN<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("FORCEX_PENDING");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_FORCPEN<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_FORCPEN<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("SUSPEND_PENDING");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_SUSPEN<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_SUSPEN<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("WAIT_ALL");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_WALL<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_WALL<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("WAKE_PENDING");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_WAKEPEN<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_WAKEPEN<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("RESUME_PENDING");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_RESPEN<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_RESPEN<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("SWAPPING");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_PSWAPM<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_PSWAPM<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("SERVICE_FAILURE");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_SSFEXCU<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_SSFEXCU<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("ACCOUNTING");
	        if (ccode & 1)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_NOACNT<<16)+PCB$L_STS,1,&0);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = rwproc(pid,RWPROC_K_WBPCB,
				(PCB$V_NOACNT<<16)+PCB$L_STS,1,&1);
			if ((ccode & 1) == 0)
				return ccode;
		}
		ccode = cli_present2("AST_ENABLED");
	        if (ccode & 1)
		{
                        ccode = setast(&pid,1);
			if ((ccode & 1) == 0)
				return ccode;
		}
	        else if (ccode == CLI$_NEGATED)
		{
                        ccode = setast(&pid,0);
			if ((ccode & 1) == 0)
				return ccode;
		}
		if (cli_present("PROCESS_NAME"))
		{
			ccode = cli_get_value("PROCESS_NAME",&p);
			if (ccode & 1)
			{
				memset(name,'\0',sizeof(name));
				strncpy(&name[1],p,sizeof(name)-1);
				if (name[sizeof(name)-1] == '\0')
					name[0] = strlen(&name[1]);
				else
					name[0] = sizeof(name)-1;
				ccode = rwproc(pid,RWPROC_K_WRPCB,
					PCB$T_LNAME,PCB$S_LNAME,name);
				if ((ccode & 1) == 0)
					return ccode;
			}
		}
		else
			ccode = XSET__NORMAL;
		if (cli_present("CRASH"))
			ccode = setproccrash(&pid,0);
	}
        return ccode;
}
